<?php
namespace Teknisa\SM\Controller;

class ReplicacaoParceiroController {
    protected $replicacaoService;
    const CLIENTE  = 'CLIENTE';
    const PROSPECT = 'PROSPECT';
    const LEAD     = 'CANDIDATO';
    const PARCEIRO = 'PARCEIRO';
    
    public function __construct ($replicacaoService) {
        $this->replicacaoService   = $replicacaoService;
    }
    
    /**
     * Função para replicar os dados entre os registros
     * de Parceiro, Lead e Prospect
     * 
     * @param $nrparcnegocio Parceiro salvo
     * @param $tipoParceiro  Tipo de parceiro salvo (CANDIDATO(Lead), PARCEIRO ou PROSPECT)
     * @param $tela          Tela em que o registro foi salvo (CANDIDATO(Lead), PARCEIRO ou PROSPECT)
     * 
     * @return string
    */
    public function replica($nrparcnegocio, $tipoParceiro, $tela){
        try{
            if(strtoupper($tipoParceiro) !== self::CLIENTE){    
                $message = "";
                if($tela === self::PARCEIRO){
                    if($tipoParceiro === self::LEAD){
                        $message .= $this->replicacaoService->replicaLead($nrparcnegocio, $tela);    
                    }else{
                        $message .= $this->replicacaoService->replicaProspect($nrparcnegocio, $tela);
                        $message .= $this->replicacaoService->replicaLead($nrparcnegocio, $tela);
                    }        
                }else if($tela === self::PROSPECT){
                    $message .= $this->replicacaoService->replicaParceiro($nrparcnegocio, $tela);
                    $message .= $this->replicacaoService->replicaLead($nrparcnegocio, $tela);
                }else{
                    $message .= $this->replicacaoService->replicaParceiro($nrparcnegocio, $tela);    
                }
                return $message;
            }else{
                return 'Clientes não são replicados';
            }
        }catch(\Exception $e){
            return $message.$e->getMessage();    
        }
    }
    
}